#include "quex_turtle_TurtleLexer"
#include <quex/code_base/analyzer/C-adaptions.h>
QUEX_NAMESPACE_MAIN_OPEN
/* Global */QUEX_NAME(Mode)  QUEX_NAME(QUERY);
#ifndef __QUEX_INDICATOR_DUMPED_TOKEN_ID_DEFINED
    static QUEX_TYPE_TOKEN_ID    QUEX_NAME_TOKEN(DumpedTokenIdObject);
#endif
#define self  (*(QUEX_TYPE_DERIVED_ANALYZER*)me)
#define __self_result_token_id    QUEX_NAME_TOKEN(DumpedTokenIdObject)

void
QUEX_NAME(QUERY_on_entry)(QUEX_TYPE_ANALYZER* me, const QUEX_NAME(Mode)* FromMode) {
    (void)me;
    (void)FromMode;
#   ifdef QUEX_OPTION_RUNTIME_MODE_TRANSITION_CHECK
    QUEX_NAME(QUERY).has_entry_from(FromMode);
#   endif

}

void
QUEX_NAME(QUERY_on_exit)(QUEX_TYPE_ANALYZER* me, const QUEX_NAME(Mode)* ToMode)  {
    (void)me;
    (void)ToMode;
#   ifdef QUEX_OPTION_RUNTIME_MODE_TRANSITION_CHECK
    QUEX_NAME(QUERY).has_exit_to(ToMode);
#   endif

}

#if defined(QUEX_OPTION_INDENTATION_TRIGGER) 
void
QUEX_NAME(QUERY_on_indentation)(QUEX_TYPE_ANALYZER*    me, 
                                        QUEX_TYPE_INDENTATION  Indentation, 
                                        QUEX_TYPE_CHARACTER*   Begin) {
    (void)me;
    (void)Indentation;
    (void)Begin;
    return;
}
#endif

#ifdef QUEX_OPTION_RUNTIME_MODE_TRANSITION_CHECK
bool
QUEX_NAME(QUERY_has_base)(const QUEX_NAME(Mode)* Mode) {
    (void)Mode;

    switch( Mode->id ) {
    case QUEX_NAME(ModeID_QUERY): return true;
    default:
    ;
    }
    __QUEX_STD_fprintf(stderr, "mode '%s' is not one of (and not a derived mode of): QUERY, \n", Mode->name);
    __quex_assert(false);
    return false;
    
}
bool
QUEX_NAME(QUERY_has_entry_from)(const QUEX_NAME(Mode)* Mode) {
    (void)Mode;
    return true; /* default */
}
bool
QUEX_NAME(QUERY_has_exit_to)(const QUEX_NAME(Mode)* Mode) {
    (void)Mode;
    return false;
}
#endif    
#undef self
#undef __self_result_token_id
QUEX_NAMESPACE_MAIN_CLOSE

/* #include "quex_turtle_TurtleLexer"*/
QUEX_NAMESPACE_MAIN_OPEN
QUEX_TYPE_CHARACTER  QUEX_LEXEME_NULL_IN_ITS_NAMESPACE = (QUEX_TYPE_CHARACTER)0;

#include <quex/code_base/analyzer/member/basic>
#include <quex/code_base/buffer/Buffer>
#ifdef QUEX_OPTION_TOKEN_POLICY_QUEUE
#   include <quex/code_base/token/TokenQueue>
#endif

#ifdef    CONTINUE
#   undef CONTINUE
#endif
#define   CONTINUE goto __REENTRY_PREPARATION; 

#ifdef    RETURN
#   undef RETURN
#endif

#if defined(QUEX_OPTION_TOKEN_POLICY_QUEUE)
#   define RETURN   return
#else
#   define RETURN   do { return __self_result_token_id; } while(0)
#endif
#include <quex/code_base/temporary_macros_on>

__QUEX_TYPE_ANALYZER_RETURN_VALUE  
QUEX_NAME(QUERY_analyzer_function)(QUEX_TYPE_ANALYZER* me) 
{
    /* NOTE: Different modes correspond to different analyzer functions. The analyzer  
             functions are all located inside the main class as static functions. That  
             means, they are something like 'globals'. They receive a pointer to the   
             lexical analyzer, since static member do not have access to the 'this' pointer.
     */
#   if defined(QUEX_OPTION_TOKEN_POLICY_SINGLE)
    register QUEX_TYPE_TOKEN_ID __self_result_token_id 
           = (QUEX_TYPE_TOKEN_ID)__QUEX_SETTING_TOKEN_ID_UNINITIALIZED;
#   endif
#   ifdef     self
#       undef self
#   endif
#   define self (*((QUEX_TYPE_ANALYZER*)me))
    const size_t                   Skipper67L                     = 1;
    QUEX_TYPE_GOTO_LABEL           target_state_index             = ((QUEX_TYPE_CHARACTER)0x0);
    QUEX_TYPE_CHARACTER*           text_end                       = (QUEX_TYPE_CHARACTER*)0x0;
    QUEX_TYPE_GOTO_LABEL           target_state_else_index        = ((QUEX_TYPE_CHARACTER)0x0);
    const size_t                   PositionRegisterN              = (size_t)0;
    QUEX_TYPE_CHARACTER            input                          = (QUEX_TYPE_CHARACTER)(0x00);
    void*                          position                       = (void*)0x0;
    const QUEX_TYPE_CHARACTER      Skipper67[1]                   = { 0xA,  };
#   ifdef QUEX_OPTION_COLUMN_NUMBER_COUNTING
    QUEX_TYPE_CHARACTER_POSITION   reference_p                    = (QUEX_TYPE_CHARACTER_POSITION)0x0;
#   endif /* QUEX_OPTION_COLUMN_NUMBER_COUNTING */
#   ifndef QUEX_OPTION_COMPUTED_GOTOS
#   endif /* QUEX_OPTION_COMPUTED_GOTOS */
#   define QUERY    (QUEX_NAME(QUERY))

    /* Post context positions do not have to be reset or initialized. If a state
     * is reached which is associated with 'end of post context' it is clear what
     * post context is meant. This results from the ways the state machine is 
     * constructed. Post context position's live cycle:
     *
     * (1)   unitialized (don't care)
     * (1.b) on buffer reload it may, or may not be adapted (don't care)
     * (2)   when a post context begin state is passed, then it is **SET** (now: take care)
     * (2.b) on buffer reload it **is adapted**.
     * (3)   when a terminal state of the post context is reached (which can only be reached
     *       for that particular post context), then the post context position is used
     *       to reset the input position.                                              */
#   if    defined(QUEX_OPTION_AUTOMATIC_ANALYSIS_CONTINUATION_ON_MODE_CHANGE) \
       || defined(QUEX_OPTION_ASSERTS)
    me->DEBUG_analyzer_function_at_entry = me->current_analyzer_function;
#   endif
__REENTRY:
    me->buffer._lexeme_start_p = me->buffer._input_p;
    QUEX_LEXEME_TERMINATING_ZERO_UNDO(&me->buffer);
INIT_STATE_TRANSITION_BLOCK:
    input = *(me->buffer._input_p);
    __quex_debug("Init State\n");
    __quex_debug_state(86);
    switch( input ) {
        case 0x0: QUEX_GOTO_RELOAD_FORWARD(86, 74);

        case 0x9: 
        case 0xA: 
        case 0xB: 
        case 0xC: 
        case 0xD: 
        case 0x20: goto _87;

        case 0x23: goto _88;

        case 0x3C: goto _89;

    }
    __quex_debug_drop_out(86);
    
    goto _94; /* TERMINAL_FAILURE */


_86: /* (86 from NONE) */


    ++(me->buffer._input_p);
    goto INIT_STATE_TRANSITION_BLOCK;


    __quex_assert_no_passage();
_91: /* (91 from 91) (91 from 89) */

    ++(me->buffer._input_p);
    input = *(me->buffer._input_p);
    __quex_debug_state(91);
    if( input < 0x3D ) {
        switch( input ) {
            case 0x0: QUEX_GOTO_RELOAD_FORWARD(91, 95);

            case 0x2: 
            case 0x3: 
            case 0x4: 
            case 0x5: 
            case 0x6: 
            case 0x7: 
            case 0x8: 
            case 0x9: 
            case 0xA: 
            case 0xB: 
            case 0xC: 
            case 0xD: 
            case 0xE: 
            case 0xF: 
            case 0x10: 
            case 0x11: 
            case 0x12: 
            case 0x13: 
            case 0x14: 
            case 0x15: 
            case 0x16: 
            case 0x17: 
            case 0x18: 
            case 0x19: 
            case 0x1A: 
            case 0x1B: 
            case 0x1C: 
            case 0x1D: 
            case 0x1E: 
            case 0x1F: 
            case 0x20: 
            case 0x21: 
            case 0x22: 
            case 0x23: 
            case 0x24: 
            case 0x25: 
            case 0x26: 
            case 0x27: 
            case 0x28: 
            case 0x29: 
            case 0x2A: 
            case 0x2B: 
            case 0x2C: 
            case 0x2D: 
            case 0x2E: 
            case 0x2F: 
            case 0x30: 
            case 0x31: 
            case 0x32: 
            case 0x33: 
            case 0x34: 
            case 0x35: 
            case 0x36: 
            case 0x37: 
            case 0x38: 
            case 0x39: 
            case 0x3A: 
            case 0x3B: goto _91;

        }
    } else {

        if( input == 0x3D ) {
            goto _91;

        } else if( input == 0x3E ) {
            goto _92;

        } else if( input < 0x110000 ) {
            goto _91;

        } else {

}    }_95:
    __quex_debug_drop_out(91);
    
    goto _94; /* TERMINAL_FAILURE */


    __quex_assert_no_passage();
_90: /* (90 from 90) (90 from 89) */

    ++(me->buffer._input_p);
    input = *(me->buffer._input_p);
    __quex_debug_state(90);
    switch( input ) {
        case 0x0: QUEX_GOTO_RELOAD_FORWARD(90, 96);

        case 0x3E: goto _90;

    }
_96:
    __quex_debug_drop_out(90);
    goto TERMINAL_23;


    __quex_assert_no_passage();
_92: /* (92 from 91) */

    ++(me->buffer._input_p);
    __quex_debug_state(92);
    __quex_debug_drop_out(92);
    goto TERMINAL_23;


    __quex_assert_no_passage();
_87: /* (87 from 86) */

    ++(me->buffer._input_p);
    __quex_debug_state(87);
    __quex_debug_drop_out(87);
    goto TERMINAL_21;


    __quex_assert_no_passage();
_88: /* (88 from 86) */

    ++(me->buffer._input_p);
    __quex_debug_state(88);
    __quex_debug_drop_out(88);
    goto TERMINAL_20;


    __quex_assert_no_passage();
_89: /* (89 from 86) */

    ++(me->buffer._input_p);
    input = *(me->buffer._input_p);
    __quex_debug_state(89);
    if( input < 0x3D ) {
        switch( input ) {
            case 0x0: QUEX_GOTO_RELOAD_FORWARD(89, 100);

            case 0x2: 
            case 0x3: 
            case 0x4: 
            case 0x5: 
            case 0x6: 
            case 0x7: 
            case 0x8: 
            case 0x9: 
            case 0xA: 
            case 0xB: 
            case 0xC: 
            case 0xD: 
            case 0xE: 
            case 0xF: 
            case 0x10: 
            case 0x11: 
            case 0x12: 
            case 0x13: 
            case 0x14: 
            case 0x15: 
            case 0x16: 
            case 0x17: 
            case 0x18: 
            case 0x19: 
            case 0x1A: 
            case 0x1B: 
            case 0x1C: 
            case 0x1D: 
            case 0x1E: 
            case 0x1F: 
            case 0x20: 
            case 0x21: 
            case 0x22: 
            case 0x23: 
            case 0x24: 
            case 0x25: 
            case 0x26: 
            case 0x27: 
            case 0x28: 
            case 0x29: 
            case 0x2A: 
            case 0x2B: 
            case 0x2C: 
            case 0x2D: 
            case 0x2E: 
            case 0x2F: 
            case 0x30: 
            case 0x31: 
            case 0x32: 
            case 0x33: 
            case 0x34: 
            case 0x35: 
            case 0x36: 
            case 0x37: 
            case 0x38: 
            case 0x39: 
            case 0x3A: 
            case 0x3B: goto _91;

        }
    } else {

        if( input == 0x3D ) {
            goto _91;

        } else if( input == 0x3E ) {
            goto _90;

        } else if( input < 0x110000 ) {
            goto _91;

        } else {

}    }_100:
    __quex_debug_drop_out(89);
    
    goto _94; /* TERMINAL_FAILURE */

    /* (*) Terminal states _______________________________________________________
     *
     * States that implement actions of the 'winner patterns.                     */

    /* Lexeme setup: 
     *
     * There is a temporary zero stored at the end of each lexeme, if the action 
     * references to the 'Lexeme'. 'LexemeNull' provides a reference to an empty
     * zero terminated string.                                                    */
#if defined(QUEX_OPTION_ASSERTS)
#   define Lexeme       QUEX_NAME(access_Lexeme)((const char*)__FILE__, (size_t)__LINE__, &me->buffer)
#   define LexemeBegin  QUEX_NAME(access_LexemeBegin)((const char*)__FILE__, (size_t)__LINE__, &me->buffer)
#   define LexemeL      QUEX_NAME(access_LexemeL)((const char*)__FILE__, (size_t)__LINE__, &me->buffer)
#   define LexemeEnd    QUEX_NAME(access_LexemeEnd)((const char*)__FILE__, (size_t)__LINE__, &me->buffer)
#else
#   define Lexeme       (me->buffer._lexeme_start_p)
#   define LexemeBegin  Lexeme
#   define LexemeL      ((size_t)(me->buffer._input_p - me->buffer._lexeme_start_p))
#   define LexemeEnd    me->buffer._input_p
#endif

#define LexemeNull      (&QUEX_LEXEME_NULL)

TERMINAL_20:
    __quex_debug("* terminal 20:   \"#\"\n");
    __QUEX_COUNT_NEWLINE_N_ZERO_COLUMN_N_FIXED(self.counter, 1);
    {
    /*                          Delimiter: '\n',  */

    text_end = QUEX_NAME(Buffer_text_end)(&me->buffer);


_68:

    QUEX_BUFFER_ASSERT_CONSISTENCY(&me->buffer);
    __quex_assert(QUEX_NAME(Buffer_content_size)(&me->buffer) >= Skipper67L );

    /* NOTE: If _input_p == end of buffer, then it will drop out immediately out of the
        *       loop below and drop into the buffer reload procedure.                      */

    /* Loop eating characters: Break-out as soon as the First Character of the Delimiter
        * (FCD) is reached. Thus, the FCD plays also the role of the Buffer Limit Code. There
        * are two reasons for break-out:
        *    (1) we reached a limit (end-of-file or buffer-limit)
        *    (2) there was really the FCD in the character stream
        * This must be distinguished after the loop was exited. But, during the 'swallowing' we
        * are very fast, because we do not have to check for two different characters.        */
    *text_end = Skipper67[0]; /* Overwrite BufferLimitCode (BLC).  */
_67_LOOP:
                    input = *(me->buffer._input_p);

            if( input == Skipper67[0] ) {

                    goto _67_LOOP_EXIT;
            }

            ++(me->buffer._input_p); /* Now, BLC cannot occur. See above. */
    goto _67_LOOP;
_67_LOOP_EXIT:

    *text_end = QUEX_SETTING_BUFFER_LIMIT_CODE; /* Reset BLC. */

    /* Case (1) and (2) from above can be distinguished easily:
        *
        *   (1) Distance to text end == 0:
        *         End-of-File or Buffer-Limit.
        *         => goto to drop-out handling
        *
        *   (2) Else:
        *         First character of delimit reached.
        *         => For the verification of the tail of the delimiter it is
        *            essential that it is loaded completely into the buffer.
        *            For this, it must be required:
        *
        *                Distance to text end >= Delimiter length
        *
        *                _input_p    end
        *                    |        |           end - _input_p >= 3
        *                [ ][R][E][M][#]
        *
        *         The case of reload should be seldom and is costy anyway.
        *         Thus let's say, that in this case we simply enter the drop
        *         out and start the search for the delimiter all over again.
        *
        *         (2.1) Distance to text end < Delimiter length
        *                => goto to drop-out handling
        *         (2.2) Start detection of tail of delimiter
        *
        */
    if( QUEX_NAME(Buffer_distance_input_to_text_end)(&me->buffer) < (ptrdiff_t)Skipper67L ) {
            /* (2.1) Reload required. */
            goto _69;
    }

    /* (2.2) Test the remaining delimiter, but note, that the check must restart at '_input_p + 1'
        *       if any later check fails. */
    ++(me->buffer._input_p);
    /* Example: Delimiter = '*', '/'; if we get ...[*][*][/]... then the the first "*" causes
        *          a drop out out of the 'swallowing loop' and the second "*" will mismatch
        *          the required "/". But, then the second "*" must be presented to the
        *          swallowing loop and the letter after it completes the 'match'.
        * (The whole discussion, of course, is superflous if the range delimiter has length 1.)  */

    {
            /* NOTE: The initial state does not increment the input_p. When it detects that
                * it is located on a buffer border, it automatically triggers a reload. No
                * need here to reload the buffer. */
            __QUEX_IF_COUNT_COLUMNS_SET((size_t)1);
            __QUEX_IF_COUNT_LINES_ADD((size_t)1);

            /* No need for re-entry preparation. Acceptance flags and modes are untouched after skipping. */
            goto __REENTRY; /* End of range reached. */
    }

_69:
    QUEX_BUFFER_ASSERT_CONSISTENCY_LIGHT(&me->buffer);
    /* -- When loading new content it is checked that the beginning of the lexeme
        *    is not 'shifted' out of the buffer. In the case of skipping, we do not care about
        *    the lexeme at all, so do not restrict the load procedure and set the lexeme start
        *    to the actual input position.                                                    */
    me->buffer._lexeme_start_p = me->buffer._input_p;


    /* -- According to case (2.1) is is possible that the _input_p does not point to the end
        *    of the buffer, thus we record the current position in the lexeme start pointer and
        *    recover it after the loading. */
    me->buffer._input_p = text_end;
    if( QUEX_NAME(Buffer_is_end_of_file)(&me->buffer) == false ) {
            QUEX_NAME(buffer_reload_forward)(&me->buffer, (QUEX_TYPE_CHARACTER_POSITION*)position, PositionRegisterN);
            /* Recover '_input_p' from lexeme start
                * (inverse of what we just did before the loading) */
            me->buffer._input_p = me->buffer._lexeme_start_p;
            /* After reload, we need to increment _input_p. That's how the game is supposed to be played.
                * But, we recovered from lexeme start pointer, and this one does not need to be incremented. */
            text_end = QUEX_NAME(Buffer_text_end)(&me->buffer);

            QUEX_BUFFER_ASSERT_CONSISTENCY(&me->buffer);
            goto _68;
    }
    /* Here, either the loading failed or it is not enough space to carry a closing delimiter */
    me->buffer._input_p = me->buffer._lexeme_start_p;
    QUEX_ERROR_EXIT("\nLexical analyzer mode 'BASE':\n"
                        "End of file occurred before closing skip range delimiter!\n"                "The 'on_skip_range_open' handler has not been specified.");

    }
    goto __REENTRY_PREPARATION;

TERMINAL_21:
    __quex_debug("* terminal 21:   [ \\t\\r\\n\\v\\f]\n");
    __QUEX_COUNT_VOID(self.counter);
    {
    /* Character set skipper state */

    /* Skip any character in ['\t', '\r'], ' ' */

    __QUEX_IF_COUNT_COLUMNS(reference_p = QUEX_NAME(Buffer_tell_memory_adr)(&me->buffer));


    QUEX_BUFFER_ASSERT_CONSISTENCY(&me->buffer);
    __quex_assert(QUEX_NAME(Buffer_content_size)(&me->buffer) >= 1);

    /* NOTE: For simple skippers the end of content does not have to be overwriten
        *       with anything (as done for range skippers). This is so, because the abort
        *       criteria is that a character occurs which does not belong to the trigger
        *       set. The BufferLimitCode, though, does never belong to any trigger set and
        *       thus, no special character is to be set.                                   */
_70_LOOP:
    input = *(me->buffer._input_p);

    __QUEX_IF_COUNT_IF( input == (QUEX_TYPE_CHARACTER)'\n' ) {
                __QUEX_IF_COUNT_LINES_ADD((size_t)1);
                __QUEX_IF_COUNT_COLUMNS_SET((size_t)0);
                __QUEX_IF_COUNT_COLUMNS(reference_p = QUEX_NAME(Buffer_tell_memory_adr)(&me->buffer));
    }

    switch( input ) {
                case 0x0: goto _71;

                case 0x9:
                case 0xA:
                case 0xB:
                case 0xC:
                case 0xD:
                case 0x20: ++(me->buffer._input_p); goto _70_LOOP;


    }
    __QUEX_IF_COUNT_COLUMNS_ADD((size_t)(me->buffer._input_p - reference_p));

    /* There was no buffer limit code, so no end of buffer or end of file --> continue analysis
        * The character we just swallowed must be re-considered by the main state machine.
        * But, note that the initial state does not increment '_input_p'!
        *
        * No need for re-entry preparation. Acceptance flags and modes are untouched after skipping. */
    goto __REENTRY;

_71:
    /* -- When loading new content it is always taken care that the beginning of the lexeme
        *    is not 'shifted' out of the buffer. In the case of skipping, we do not care about
        *    the lexeme at all, so do not restrict the load procedure and set the lexeme start
        *    to the actual input position.
        * -- The input_p will at this point in time always point to the buffer border.        */
    __quex_assert(input == QUEX_SETTING_BUFFER_LIMIT_CODE);
    QUEX_BUFFER_ASSERT_CONSISTENCY(&me->buffer);
    __QUEX_IF_COUNT_COLUMNS_ADD((size_t)(me->buffer._input_p - reference_p));

    me->buffer._lexeme_start_p = me->buffer._input_p;
    if( QUEX_NAME(Buffer_is_end_of_file)(&me->buffer) ) {
                goto _74;
    } else {
                QUEX_NAME(buffer_reload_forward)(&me->buffer, (QUEX_TYPE_CHARACTER_POSITION*)position, PositionRegisterN);
                QUEX_BUFFER_ASSERT_CONSISTENCY(&me->buffer);
                ++(me->buffer._input_p); /* Now, BLC cannot occur. See above. */
            __QUEX_IF_COUNT_COLUMNS(reference_p = me->buffer._input_p);

                goto _70_LOOP;
    }

    }
    goto __REENTRY_PREPARATION;

TERMINAL_23:
    __quex_debug("* terminal 23:   {IRI_REF}\n");
    __QUEX_COUNT_VOID(self.counter);
    QUEX_LEXEME_TERMINATING_ZERO_SET(&me->buffer);
    {
#   line 16 "program.qx"
    
        self_accumulator_add(Lexeme+1, LexemeEnd-1);
        self_accumulator_flush(QUEX_TKN_BASE_IRI_REF);
            RETURN;
    
    
#   line 635 "quex_turtle_TurtleLexer.cpp"

    }
    goto __REENTRY_PREPARATION;

_74: /* TERMINAL: END_OF_STREAM */
    __QUEX_COUNT_END_OF_STREAM_EVENT(self.counter);
    {
#   line 4 "end_of_file.qx"
    
            /* NOTE: The local variable is deleted soon, but the sender copies the
                *       content into a string object.                                  */
        self_send1(QUEX_TKN_TERMINATION, LexemeNull);
            RETURN;
    
    
#   line 651 "quex_turtle_TurtleLexer.cpp"

    }
    /* End of Stream causes a return from the lexical analyzer, so that no
     * tokens can be filled after the termination token.                    */
    RETURN;          

_94: /* TERMINAL: FAILURE */
    if(QUEX_NAME(Buffer_is_end_of_file)(&me->buffer)) {
        /* Init state is going to detect 'input == buffer limit code', and
         * enter the reload procedure, which will decide about 'end of stream'. */
    } else {
        /* In init state 'input = *input_p' and we need to increment
         * in order to avoid getting stalled. Else, input = *(input_p - 1),
         * so 'input_p' points already to the next character.              */
        if( me->buffer._input_p == me->buffer._lexeme_start_p ) {
            /* Step over non-matching character */
            ++(me->buffer._input_p);
        }
    }
    __QUEX_COUNT_VOID(self.counter);
    {
#   line 10 "program.qx"
    QUEX_NAME_TOKEN(take_text)(self_write_token_p(), &self, self.buffer._lexeme_start_p, self.buffer._input_p);
    self_send(QUEX_TKN_LEXEME_NOT_FOUND);
    QUEX_SETTING_AFTER_SEND_CONTINUE_OR_RETURN();
    
#   line 678 "quex_turtle_TurtleLexer.cpp"

    }
    goto __REENTRY_PREPARATION;

__REENTRY_PREPARATION:
    /* (*) Common point for **restarting** lexical analysis.
     *     at each time when CONTINUE is called at the end of a pattern. */
 

#   undef Lexeme
#   undef LexemeBegin
#   undef LexemeEnd
#   undef LexemeNull
#   undef LexemeL

#   ifndef __QUEX_OPTION_PLAIN_ANALYZER_OBJECT
#   ifdef  QUEX_OPTION_TOKEN_POLICY_QUEUE
    if( QUEX_NAME(TokenQueue_is_full)(&self._token_queue) ) RETURN;
#   else
    if( self_token_get_id() != __QUEX_SETTING_TOKEN_ID_UNINITIALIZED) RETURN;
#   endif
#   endif
    


    /* Post context positions do not have to be reset or initialized. If a state
     * is reached which is associated with 'end of post context' it is clear what
     * post context is meant. This results from the ways the state machine is 
     * constructed. Post context position's live cycle:
     *
     * (1)   unitialized (don't care)
     * (1.b) on buffer reload it may, or may not be adapted (don't care)
     * (2)   when a post context begin state is passed, then it is **SET** (now: take care)
     * (2.b) on buffer reload it **is adapted**.
     * (3)   when a terminal state of the post context is reached (which can only be reached
     *       for that particular post context), then the post context position is used
     *       to reset the input position.                                              */

    /*  If a mode change happened, then the function must first return and
     *  indicate that another mode function is to be called. At this point, 
     *  we to force a 'return' on a mode change. 
     *
     *  Pseudo Code: if( previous_mode != current_mode ) {
     *                   return 0;
     *               }
     *
     *  When the analyzer returns, the caller function has to watch if a mode change
     *  occurred. If not it can call this function again.                               */
#   if    defined(QUEX_OPTION_AUTOMATIC_ANALYSIS_CONTINUATION_ON_MODE_CHANGE)        || defined(QUEX_OPTION_ASSERTS)
    if( me->DEBUG_analyzer_function_at_entry != me->current_analyzer_function ) 
#   endif
    { 
#       if defined(QUEX_OPTION_AUTOMATIC_ANALYSIS_CONTINUATION_ON_MODE_CHANGE)
        self_token_set_id(__QUEX_SETTING_TOKEN_ID_UNINITIALIZED);
        RETURN;
#       elif defined(QUEX_OPTION_ASSERTS)
        QUEX_ERROR_EXIT("Mode change without immediate return from the lexical analyzer.");
#       endif
    }

    goto __REENTRY;

    __quex_assert_no_passage();
__RELOAD_FORWARD:
    __quex_debug1("__RELOAD_FORWARD");

    __quex_assert(input == QUEX_SETTING_BUFFER_LIMIT_CODE);
    if( me->buffer._memory._end_of_file_p == 0x0 ) {
        __quex_debug_reload_before();
        QUEX_NAME(buffer_reload_forward)(&me->buffer, (QUEX_TYPE_CHARACTER_POSITION*)position, PositionRegisterN);
        __quex_debug_reload_after();
        QUEX_GOTO_STATE(target_state_index);
    }
    __quex_debug("reload impossible\n");
    QUEX_GOTO_STATE(target_state_else_index);
#   ifndef QUEX_OPTION_COMPUTED_GOTOS
    __quex_assert_no_passage();
__STATE_ROUTER:
    switch( target_state_index ) {
        case 74: { goto _74; }
        case 86: { goto _86; }
        case 87: { goto _87; }
        case 88: { goto _88; }
        case 89: { goto _89; }
        case 90: { goto _90; }
        case 91: { goto _91; }
        case 92: { goto _92; }
        case 95: { goto _95; }
        case 96: { goto _96; }
        case 100: { goto _100; }

        default:
            __QUEX_STD_fprintf(stderr, "State router: index = %i\n", (int)target_state_index);
            QUEX_ERROR_EXIT("State router: unknown index.");
    }
#   endif /* QUEX_OPTION_COMPUTED_GOTOS */

    /* Prevent compiler warning 'unused variable': use variables once in a part of the code*/
    /* that is never reached (and deleted by the compiler anyway).*/
    (void)QUEX_LEXEME_NULL;
    (void)QUEX_NAME_TOKEN(DumpedTokenIdObject);
    QUEX_ERROR_EXIT("Unreachable code has been reached.\n");
#   undef QUERY
#   undef self
}
#include <quex/code_base/temporary_macros_off>
QUEX_NAMESPACE_MAIN_CLOSE


QUEX_NAMESPACE_TOKEN_OPEN

const char*
QUEX_NAME_TOKEN(map_id_to_name)(const QUEX_TYPE_TOKEN_ID TokenID)
{
   static char  error_string[64];
   static const char  uninitialized_string[] = "<UNINITIALIZED>";
   static const char  termination_string[]   = "<TERMINATION>";
#  if defined(QUEX_OPTION_INDENTATION_TRIGGER)
   static const char  indent_string[]        = "<INDENT>";
   static const char  dedent_string[]        = "<DEDENT>";
   static const char  nodent_string[]        = "<NODENT>";
#  endif
   static const char  token_id_str_BASE_IRI_REF[]     = "BASE_IRI_REF";
   static const char  token_id_str_LEXEME_NOT_FOUND[] = "LEXEME_NOT_FOUND";
   static const char  token_id_str_LINE_TERMINATION[] = "LINE_TERMINATION";
       

   /* NOTE: This implementation works only for token id types that are 
    *       some type of integer or enum. In case an alien type is to
    *       used, this function needs to be redefined.                  */
   switch( TokenID ) {
   default: {
       __QUEX_STD_sprintf(error_string, "<UNKNOWN TOKEN-ID: %i>", (int)TokenID);
       return error_string;
   }
   case QUEX_TKN_TERMINATION:    return termination_string;
   case QUEX_TKN_UNINITIALIZED:  return uninitialized_string;
#  if defined(QUEX_OPTION_INDENTATION_TRIGGER)
   case QUEX_TKN_INDENT:         return indent_string;
   case QUEX_TKN_DEDENT:         return dedent_string;
   case QUEX_TKN_NODENT:         return nodent_string;
#  endif
   case QUEX_TKN_BASE_IRI_REF:     return token_id_str_BASE_IRI_REF;
   case QUEX_TKN_LEXEME_NOT_FOUND: return token_id_str_LEXEME_NOT_FOUND;
   case QUEX_TKN_LINE_TERMINATION: return token_id_str_LINE_TERMINATION;

   }
}

QUEX_NAMESPACE_TOKEN_CLOSE

