#include "TurtleParser.h"

// This is the only function that is called, the stack corruption happends here
void CTurtleParser::OnlyCalledFunction()
{
	// You must put a breakpoint here to get the stack corruption error
	std::cout << "If you see this message then you have not put a debug breakpoint at line 20 in TurtleParser.cpp, or you are not compiling with Intel C++ 14.0" << std::endl;
}

// This function is never called, but if you comment out the code inside it the stack corruption does not happen
void CTurtleParser::ThisFunctionIsNeverCalledButStillCausesTheError(FILE* fh, const char *encoding)
{
    // Even though this line of code is never called it still triggers the stack corruption, thus commenting it out will prevent the error
    quex::turtle::TurtleLexer *qlex = new quex::turtle::TurtleLexer(fh, encoding);

	/*
	However, if we change the above line to
		quex::turtle::TurtleLexer qlex(fh, encoding);
	then the stack corruption does not happen, so it seems something with the "new" keywords that triggers it 
	*/
}
